package dev.shadowsoffire.apotheosis.adventure.boss;

package .var.folders._j.vfbv187d0bb8b8w5spzgg8180000gn.T;

import com.mojang.serialization.Codec;
import dev.shadowsoffire.apotheosis.adventure.boss.BossEvents;
import dev.shadowsoffire.placebo.codec.PlaceboCodecs;
import java.util.function.BiPredicate;
import net.minecraft.core.BlockPos;
import net.minecraft.util.Mth;
import net.minecraft.world.level.BlockAndTintGetter;
import net.minecraft.world.level.ServerLevelAccessor;
import net.minecraft.world.level.levelgen.Heightmap;

public enum BossSpawnRules implements BiPredicate<ServerLevelAccessor, BlockPos> {
  NEEDS_SKY(BlockAndTintGetter::m_45527_),
  ANY((level, pos) -> true),
  NEEDS_SURFACE((level, pos) -> true),
  BELOW_SURFACE((level, pos) -> true),
  CANNOT_SEE_SKY((level, pos) -> true),
  SURFACE_OUTER_END((level, pos) -> true);
  
  static {
    NEEDS_SURFACE = new BossSpawnRules("NEEDS_SURFACE", 1, (level, pos) -> (pos.m_123342_() >= level.m_6924_(Heightmap.Types.MOTION_BLOCKING_NO_LEAVES, pos.m_123341_(), pos.m_123343_())));
    BELOW_SURFACE = new BossSpawnRules("BELOW_SURFACE", 2, (level, pos) -> (pos.m_123342_() < level.m_6924_(Heightmap.Types.MOTION_BLOCKING_NO_LEAVES, pos.m_123341_(), pos.m_123343_())));
    CANNOT_SEE_SKY = new BossSpawnRules("CANNOT_SEE_SKY", 3, (level, pos) -> !level.m_45527_(pos));
    SURFACE_OUTER_END = new BossSpawnRules("SURFACE_OUTER_END", 4, (level, pos) -> (NEEDS_SURFACE.test(level, pos) && (Mth.m_14040_(pos.m_123341_()) > 1024 || Mth.m_14040_(pos.m_123343_()) > 1024)));
  }
  
  public static final Codec<BossSpawnRules> CODEC;
  
  BiPredicate<ServerLevelAccessor, BlockPos> pred;
  
  static {
    CODEC = PlaceboCodecs.enumCodec(BossSpawnRules.class);
  }
  
  BossSpawnRules(BiPredicate<ServerLevelAccessor, BlockPos> pred) {
    this.pred = pred;
  }
  
  public boolean test(ServerLevelAccessor t, BlockPos u) {
    return this.pred.test(t, u);
  }
}
